%******************
% Code to generate Figure 2 of
% "Assymmetry, Complementarities, and State Dependence in Federal Reserve
% Forecasts"
% Caunedo, DiCecio, Komunjer, Owyang 2018
% 
%******************

close all
load ess

es=ess.uno;
z=[es(2,101:5100)' es(3,101:5100)'];

[ff,xx,yy]  =   ksdensity2d(z);

fig1    = figure;
ax1     = axes('Parent',fig1,'PlotBoxAspectRatio',[4 4 1],'Layer','top',...
    'FontSize',16,'FontName','Times New Roman','DataAspectRatio',[1 1 1]);
box(ax1,'on'),hold(ax1,'all');

contour(xx,yy,ff,5,'LineWidth',2,'LineColor',[0.75 0.75 0.75]);
plot([0 0],[-4 4],'k--',[-4 4],[0 0],'k--'),hold off
axis([-4 4 -4 4])
max_height = max(max(ff));
[x_max,y_max] = find(ff==max_height);
corr1   =   corr(z);
[xx(x_max,1) yy(1,y_max) corr1(1,2)]
title('{\bf\tau} = (\tau_{1}, \tau_{2}) = (-0.2, -0.6)','FontSize',16,'FontName','Times New Roman');
xlabel('e_{1}','FontSize',16,'FontName','Times New Roman');
ylabel('e_{2}','FontSize',16,'FontName','Times New Roman');
print -depsc asym(-)R

es=ess.dos;
z=[es(2,101:5100)' es(3,101:5100)'];

[ff,xx,yy]  =   ksdensity2d(z);

fig2    = figure;
ax2     = axes('Parent',fig2,'PlotBoxAspectRatio',[4 4 1],'Layer','top',...
    'FontSize',16,'FontName','Times New Roman','DataAspectRatio',[1 1 1]);
box(ax2,'on'),hold(ax2,'all');

contour(xx,yy,ff,5,'LineWidth',2,'LineColor',[0.75 0.75 0.75]);
axis equal
hold on
plot([0 0],[-4 4],'k--',[-4 4],[0 0],'k--'),hold off
axis([-4 4 -4 4])
max_height = max(max(ff));
[x_max,y_max] = find(ff==max_height);
corr2   =   corr(z);
[xx(x_max,1) yy(1,y_max) corr2(1,2)]
title('{\bf\tau} = (\tau_{1}, \tau_{2}) = (0, 0)','FontSize',16,'FontName','Times New Roman');
xlabel('e_{1}','FontSize',16,'FontName','Times New Roman');
ylabel('e_{2}','FontSize',16,'FontName','Times New Roman');
print -depsc symR

es=ess.tres;
z=[es(2,101:5100)' es(3,101:5100)'];

[ff,xx,yy]  =   ksdensity2d(z);

fig3    = figure;
ax3     = axes('Parent',fig3,'PlotBoxAspectRatio',[4 4 1],'Layer','top',...
    'FontSize',16,'FontName','Times New Roman','DataAspectRatio',[1 1 1]);
box(ax3,'on'),hold(ax3,'all');

contour(xx,yy,ff,5,'LineWidth',2,'LineColor',[0.75 0.75 0.75]);
axis equal
hold on
plot([0 0],[-4 4],'k--',[-4 4],[0 0],'k--'),hold off
axis([-4 4 -4 4])
max_height = max(max(ff));
[x_max,y_max] = find(ff==max_height);
corr3   =   corr(z);
[xx(x_max,1) yy(1,y_max) corr3(1,2)]
title('{\bf\tau} = (\tau_{1}, \tau_{2}) = (0.2, 0.6)','FontSize',16,'FontName','Times New Roman');
xlabel('e_{1}','FontSize',16,'FontName','Times New Roman');
ylabel('e_{2}','FontSize',16,'FontName','Times New Roman');
print -depsc asym(+)R


