function [res res2] = gmm_multi3ikTest(ERROR_SERIES,INSTRUMENTS,P)

global WEIGHT_WT_1 WEIGHT_WT_2 P ERROR_SERIES INSTRUMENTS PiSB BRT...
    ERROR_SERIES1 INSTRUMENTS1 ERROR_SERIES2 INSTRUMENTS2 WEIGHT_WT_2SB1 WEIGHT_WT_2SB2...
    WEIGHT_WT_1SB1 WEIGHT_WT_1SB2;

% Checking the validity of instruments
res.dd = det(INSTRUMENTS'*INSTRUMENTS/size(INSTRUMENTS,1));
% % true process
% U = randn(110,2);
% ERROR_SERIES = U(3:102,:);      % size is 100 x 2
% INSTRUMENTS = [ones(100,1), U(2:101,:), U(1:100,:)];    % size is 100 x 5
% estimation
% pi size of regime 1

n=size(ERROR_SERIES,2);
par0 = [0.5; 0.15; 0.15]; % starting values are the true values

%COMMENTED JUST FOR DEBUGGING
[parGMM_2, fGMM_2, retcodeGMM_2,parGMM_1, fGMM_1, retcodeGMM_1] = GMMmultiloss3(par0);

res.alfa_1 = parGMM_1(end,:);
J1 = size(ERROR_SERIES,1)*fGMM_1;
res.Jtest_1 = J1;
res.alfa_2 = parGMM_2(end,:);
J2 = size(ERROR_SERIES,1)*fGMM_2;
res.Jtest_2 =J2;


parZ0= par0;

[parGMM_2Test, fGMM_2Test, retcodeGMM_2Test] = GMMmultiloss3Test(parZ0);
res.alfa_brk1=parGMM_2Test(end,1:n);
res.alfa_brk2=parGMM_2Test(end,n+1:2*n);
    
[parGMM_1Test, fGMM_1Test, retcodeGMM_1Test] = GMMmultiloss3Testu(parZ0);
res.alfau_brk1=parGMM_1Test(end,1:n);
res.alfau_brk2=parGMM_1Test(end,n+1:2*n);

PAR_GMM_1 = res.alfa_1';
PAR_GMM_2 = res.alfa_2';
PAR_GMM_2br1= res.alfa_brk1';
PAR_GMM_2br2= res.alfa_brk2';
PAR_GMM_1br1= res.alfau_brk1';
PAR_GMM_1br2= res.alfau_brk2';
% testing the symmetry of alphas
TT = size(ERROR_SERIES,1);
dd = size(PAR_GMM_2,1);
stderrm2 = []; res_sym2_1m = []; res_sym2_2m = []; res_sym2_3m = []; res_sym2_4m = [];
stderrm1 = []; res_sym1_1m = []; res_sym1_2m = []; res_sym1_3m = []; res_sym1_4m = [];
%delta = (0.4:0.01:0.5)'; % smoothing parameter
delta = 0.5;
for inddel = 1:1:size(delta,1)
    Gama2 = PPgrad('ObjFctGMMmulti2G',dd, PAR_GMM_2, TT, delta(inddel)); 
    Gama1 = PPgrad('ObjFctGMMuni1G',dd, PAR_GMM_1, TT, delta(inddel)); 
    
    % computing the var-covar matrix of the estimator at the optimum
    CovMatrix2 = inv(Gama2*WEIGHT_WT_2*Gama2')/TT;  stderr2 = diag(CovMatrix2,0).^0.5;
    CovMatrix1 = inv(Gama1*WEIGHT_WT_1*Gama1')/TT;  stderr1 = diag(CovMatrix1,0).^0.5;   
    % symmetry Wald-type tests
    % alpha1 = alpha2 = 0.5 alpha3 unrestricted
    R1 = zeros(2,3); R1(1,1) = 1; R1(2,2) = 1;      % combination on coefficients matrix
    sym2_1 = (PAR_GMM_2(1:2)-[0.5;0.5])'*inv(R1*CovMatrix2*R1')*(PAR_GMM_2(1:2)-[0.5;0.5]);
    sym1_1 = (PAR_GMM_1(1:2)-[0.5;0.5])'*inv(R1*CovMatrix1*R1')*(PAR_GMM_1(1:2)-[0.5;0.5]);
    res_sym2_1 = (sym2_1 <= chi2inv(.90,size(R1,1)));
    res_sym1_1 = (sym1_1 <= chi2inv(.90,size(R1,1)));
    stderrm2 = [stderrm2; stderr2']; % stores standard errors of alphas for all deltas
    stderrm1 = [stderrm1; stderr1']; 
    res_sym2_1m = [res_sym2_1m; res_sym2_1]; 
    res_sym1_1m = [res_sym1_1m; res_sym1_1]; 
    % alpha1 = 0.5 other alphas unrestricted 
    sym2_2 = (PAR_GMM_2(1) - 0.5)^2/stderr2(1)^2; sym1_2 = (PAR_GMM_1(1) - 0.5)^2/stderr1(1)^2; 
    res_sym2_2 = (sym2_2 <= chi2inv(.90,1)); res_sym1_2 = (sym1_2 <= chi2inv(.90,1));
    res_sym2_2m = [res_sym2_2m; res_sym2_2]; res_sym1_2m = [res_sym1_2m; res_sym1_2];
    % alpha2 = 0.5 other unrestricted
    sym2_3 = (PAR_GMM_2(2) - 0.5)^2/stderr2(2)^2; sym1_3 = (PAR_GMM_1(2) - 0.5)^2/stderr1(2)^2; 
    res_sym2_3 = (sym2_3 <= chi2inv(.90,1)); res_sym1_3 = (sym1_3 <= chi2inv(.90,1));
    res_sym2_3m = [res_sym2_3m; res_sym2_3]; res_sym1_3m = [res_sym1_3m; res_sym1_3];
    % alpha3 = 0.5 other unrestricted
    sym2_4 = (PAR_GMM_2(3) - 0.5)^2/stderr2(3)^2; sym1_4 = (PAR_GMM_1(3) - 0.5)^2/stderr1(3)^2; 
    res_sym2_4 = (sym2_4 <= chi2inv(.90,1)); res_sym1_4 = (sym1_4 <= chi2inv(.90,1));
    res_sym2_4m = [res_sym2_4m; res_sym2_4]; res_sym1_4m = [res_sym1_4m; res_sym1_4];    
    
    %Test of Structural Break

    %Covariance Matrix
%     TT = size(ERROR_SERIES,1);
%     dd = size(PAR_GMM_2br1,1);
    Gama2T1 = PPgrad1('ObjFctGMMmulti2GTest1',dd, [PAR_GMM_2br1], TT, delta(inddel)); 
    Gama2T2 = PPgrad2('ObjFctGMMmulti2GTest2',dd, [PAR_GMM_2br2], TT, delta(inddel)); 
    Gama1T1 = PPgrad1('ObjFctGMMuni1GTest1',dd, [PAR_GMM_1br1], TT, delta(inddel)); 
     Gama1T2 = PPgrad2('ObjFctGMMuni1GTest2',dd, [PAR_GMM_1br2], TT, delta(inddel)); 
%      size(Gama2T1)
%      size(WEIGHT_WT_2SB1)
    CovMatSB=inv(Gama2T1*WEIGHT_WT_2SB1*Gama2T1')/PiSB+inv(Gama2T2*WEIGHT_WT_2SB2*Gama2T2')/(1-PiSB); 
    stderrSB = diag(CovMatSB,0).^0.5;
%     test
    sym2_SB = TT*(PAR_GMM_2br2-PAR_GMM_2br1)'*inv(CovMatSB)*(PAR_GMM_2br2-PAR_GMM_2br1);
    res_sym2_SB= (sym2_SB <= chi2inv(.90,size(ERROR_SERIES,2)));
    p_valueSB= 1-chi2cdf(sym2_SB,size(ERROR_SERIES,2));
    
    %Test of Structural Break Separable
    %Covariance Matrix
    CovMatSB1=inv(Gama1T1*WEIGHT_WT_1SB1*Gama1T1')/PiSB+inv(Gama1T2*WEIGHT_WT_1SB2*Gama1T2')/(1-PiSB); 
    stderrSB1 = diag(CovMatSB1,0).^0.5;
    sym1_SB = TT*(PAR_GMM_1br2-PAR_GMM_1br1)'*inv(CovMatSB1)*(PAR_GMM_1br2-PAR_GMM_1br1);
    res_sym1_SB= (sym1_SB <= chi2inv(.90,size(ERROR_SERIES,2)));
    p_valueSB1= 1-chi2cdf(sym1_SB,size(ERROR_SERIES,2));
    
    %Variable per Variable
    for i=1:n
          % Non-separable
        sym2_SBind(i)=TT*((PAR_GMM_2br2(i)-PAR_GMM_2br1(i))/stderrSB(i))^2 ;
        res_sym2_SBind(i)=(sym2_SBind(i) <= chi2inv(.90,1));
        p_valueSB2ind(i)= 1-chi2cdf(sym2_SBind(i),1);
        % Separable
        sym1_SBind(i)=TT*((PAR_GMM_1br2(i)-PAR_GMM_1br1(i))/stderrSB1(i))^2 ;
        res_sym1_SBind(i)=(sym1_SBind(i) <= chi2inv(.90,1));
        p_valueSB1ind(i)= 1-chi2cdf(sym1_SBind(i),1);
    end 
    
end
res2.stderrm2 = stderrm2;
res2.stderrm1 = stderrm1;
res2.stderrSB = stderrSB;
res2.wald = sym2_SB;
res2.wald1= sym1_SB;
res2.pvw =p_valueSB;
res2.pvw1= p_valueSB1;
res2.waldindNS1=sym2_SBind(1);
res2.waldindNS2=sym2_SBind(2);
res2.waldindNS3=sym2_SBind(3);
res2.pvwindNS1=p_valueSB2ind(1);
res2.pvwindNS2=p_valueSB2ind(2);
res2.pvwindNS3=p_valueSB2ind(3);

res2.waldind1=sym1_SBind(1);
res2.waldind2=sym1_SBind(2);
res2.waldind3=sym1_SBind(3);
res2.pvwind1=p_valueSB1ind(1);
res2.pvwind2=p_valueSB1ind(2);
res2.pvwind3=p_valueSB1ind(3);

res2.res_sym2_1m = res_sym2_1m;
res2.res_sym1_1m = res_sym1_1m;
res2.res_sym2_2m = res_sym2_2m;
res2.res_sym1_2m = res_sym1_2m;
res2.res_sym2_3m = res_sym2_3m;
res2.res_sym1_3m = res_sym1_3m;
res2.res_sym2_4m = res_sym2_4m;
res2.res_sym1_4m = res_sym1_4m;
res2.res_sym2_SB=res_sym2_SB;
res2.res_sym1_SB=res_sym1_SB;

res2.res_sym1_SBind1=res_sym1_SBind(1);
res2.res_sym1_SBind2=res_sym1_SBind(2);
res2.res_sym1_SBind3=res_sym1_SBind(3);









