%   Ivana Monte Carlo
%   ******************************************************************
%   This program creates the monte carlo results for Komunjer and Owyang
%       The program is designed to generate forecast error data using a recursive forecasting method
%       The forecast errors are then used to estimate the forecaster loss using both the separable and nonseparable
%       loss functions

%   ******************************************************************
%   this part of the program generates artificial data for komunjer and owyang
%   the actual data is generated from a trivariate ar(1)
%   the forecast's are generated from a loss function which minimizes the expected forecast error
%   the forecasts are generated recursively with an estimation period of 100

%   instruments are the past values of x.
%   estimate the alphas with univariate.
%   vary the form of the A matrix, sigma
%   start three ar(1)...diagonal terms in sigma
%   150 forecast samples with estimation period of 200
%   changing alpha....symmetric case, asymmetric case
function [results3] = ivana_mc_1(data)
warning off
%   User defined preferences
T_drop = 1000;%   the number of data samples dropped off to remove initial conditions

%   ******************************************************************
global ERROR_SERIES INSTRUMENTS P;
%   parameters used to generate the actual data
P = 2;
i = 1;k = 1;
for j = 1:2
    es = data(i,j,k).error_series;
    inst = data(i,j,k).inst;
    for n = 1:200
        %   ******************************************************************
        %   estimation
        disp(['Estimation',' i = ',num2str(i),' j = ',num2str(j),' k = ',num2str(k),' n = ',num2str(n)])
        ERROR_SERIES = es(:,1+T_drop:end)';
        INSTRUMENTS = [ones(size(inst,2)-T_drop,1) (inst(1:3,1 + T_drop:end))'];
        results3(j,n) = gmm_multi3ik(ERROR_SERIES,INSTRUMENTS);
    end,
end,










