function [inst] = shapeinst3(instrum);
%   X is 44 columns long
%   column 1 is a constant
%   column 2 - 4 are lagged forecasts
%   column 5 - 8 are lagged GDP
%   column 9 - 20 are lagged CPI
%   column 21 - 32 are lagged UR
%   column 33 - 44 are lagged FFR

% takes const + lagged forecasts
inst(1).X = [instrum(:,1), instrum(:,[2 3 4])];
% takes const 3 lag of FFR (was one lag GDP, one lag CPI)
inst(2).X = [instrum(:,1), instrum(:,[33 34 35])];
% takes const + 1 lag of GDP + 1 lag of CPI + 1 lag FFR
inst(3).X = [instrum(:,1), instrum(:,[5 9]) * 100, instrum(:,33)];
% takes const + 1 lag of forecasts + 1 lag of GDP and 1 lag of CPI + 1 lag FFR
inst(4).X = [instrum(:,1),instrum(:,[2 3 4]), instrum(:,[5 9]) * 100, instrum(:,33)];
% takes const + 1 lag of forecasts + 1 lag of GDP and 1 lag of CPI + 1 lag of FFR + 1 lag of UR
inst(5).X = [instrum(:,1),instrum(:,[2 3 4]), instrum(:,[5 9]) * 100, instrum(:,[21 33])];
% takes const + 1 lag of GDP and 1 lag of CPI + 1 lag of FFR + 1 lag of UR
inst(6).X = [instrum(:,1), instrum(:,[5 9]) * 100, instrum(:,[21 33])];  


% takes const + 1 lag of GDP + 3 lag of CPI
inst(7).X = [instrum(:,1), instrum(:,[5 9:11]) * 100];
% takes const + 1 lag of forecasts + 1 lag of GDP and 3 lag of CPI
inst(8).X = [instrum(:,1),instrum(:,[2 3 4]), instrum(:,[5 9:11]) * 100];
% takes const + 1 lag of GDP and 3 lag of CPI + 3 lag of FFR
inst(9).X = [instrum(:,1), instrum(:,[5 9:11]) * 100, instrum(:,[21:23 33:35])];
% takes const + 1 lag of forecasts + 1 lag of GDP and 3 lag of CPI + 3 lag of FFR
inst(10).X = [instrum(:,1),instrum(:,[2 3 4]), instrum(:,[5 9:11]) * 100, instrum(:,[21:23 33:35])];


% % takes const + 4 lag of GDP + 12 lag of CPI
% inst(11).X = [instrum(:,1), instrum(:,[4:19])];
% % takes const + 1 lag forecast + 4 lag of GDP + 12 lag of CPI
% inst(12).X = [instrum(:,1),instrum(:,[2 3])/100, instrum(:,[4:19])];
% % takes const + 4 lags of GDP + 12 lags of CPI + 12 lags of FFR + 12 lags of UR
% inst(13).X = [instrum(:,1), instrum(:,[4:19]),instrum(:,[20:end])/100];
% % takes const + lagged forecasts + 4 lags of GDP + 12 lags of CPI + 12 lags of FFR + 12 lags of UR
% inst(14).X = [instrum(:,1),instrum(:,[2 3])/100, instrum(:,[4:19]),instrum(:,[20:end])/100];



