%   This function creates the Markov switching VAR data

function [data, params,S_ta] = sim_msvar(N,P,T)

%   Parameters
%   A1
params.A1 = 0.5 * eye(N);
params.A1(2,1) = -0.2;
params.A1(1,3) = -0.1;
for p = 2:P
    params.A1 = [params.A1 , 0.05 * eye(N)];
end,
params.A1 = [1.5 * ones(N,1) , params.A1];
%   A2
params.A2 = 0.1 * eye(N);
params.A2(2,1) = -0.1;
params.A2(1,3) = 0.1;
for p = 2:P
    params.A2 = [params.A2 , 0.05 * eye(N)];
end,
params.A2 = [-3 * ones(N,1) , params.A2];
params.sig1 = eye(N);
params.sig2 = eye(N);
params.P11 = 0.85;
params.P22 = 0.92;
%   Initialize the simulator
Y_tm1 = zeros(N*P,1);
S_tm1 = 0;
data = zeros(N,T);
S_ta=[];
for t = 1:T+10000
    u = unifrnd(0,1);
    if S_tm1 == 0
        S_t = u > params.P11;
    else
        S_t = u < params.P22;
    end,
    sig_t = S_t * params.sig1 + (1-S_t) * params.sig2;
    e_t = chol(sig_t,'lower') * normrnd(0,1,N,1);
    A_t = S_t * params.A1 + (1-S_t) * params.A2;
    X_t = [1;Y_tm1];
    Y_t = A_t * X_t + e_t;
    S_ta=[S_ta;S_t];
    %   Storage
    if t > 10000
        t_star = t - 10000;
        data(:,t_star) = Y_t;
    end,
    %   Update
    S_tm1 = S_t;
    Y_tm1 = [Y_t ; Y_tm1(1:end-N)];
end,















